import os
import pathlib

from griddly import GymWrapperFactory, gd, GymWrapper
import gym


env_name = 'tawqir-aliens'
GymWrapper.metadata = {"render_modes": ["human", "rgb_array"]}


def get_base_dir():
    return pathlib.Path(__file__).parent.resolve()


if __name__ == "__main__":
    root_dir = get_base_dir()
    image_dir = os.path.join(root_dir, 'aliens/resources')
    config_dir = os.path.join(root_dir, 'aliens/gdy')

    wrapper = GymWrapperFactory()
    wrapper.build_gym_from_yaml(env_name, 'gdy/aliens.yml')
    env = gym.make(f'GDY-{env_name}-v0',
                   disable_env_checker=True,
                   gdy_path=config_dir,
                   image_path=image_dir,
                   player_observer_type=gd.ObserverType.ISOMETRIC,
                   global_observer_type=gd.ObserverType.ISOMETRIC)
    env.reset()

    for i in range(10000):
        obs, reward, done, info = env.step(env.action_space.sample())

        env.render(observer="global")
        # for p in range(env.player_count):
        #     env.render(observer=p)  # Renders the environment from the perspective of a single player

        if done:
            break
